from typing import Any
from uuid import UUID

class IntConverter:
    regex: str
    def to_python(self, value: str) -> int: ...
    def to_url(self, value: str | int) -> str: ...

class StringConverter:
    regex: str
    def to_python(self, value: str) -> str: ...
    def to_url(self, value: str) -> str: ...

class UUIDConverter:
    regex: str
    def to_python(self, value: str) -> UUID: ...
    def to_url(self, value: str | UUID) -> str: ...

class SlugConverter(StringConverter): ...
class PathConverter(StringConverter): ...

DEFAULT_CONVERTERS: dict[str, Any]
REGISTERED_CONVERTERS: dict[str, Any]

def register_converter(converter: type[Any], type_name: str) -> None: ...
def get_converters() -> dict[str, Any]: ...
def get_converter(raw_converter: str) -> Any: ...
